require "path"

function love.load()

	width, height, fullscreen, vsync, fsaa = love.graphics.getMode()

	dude = {}
	command = {}
	hover = {}
	current = {}

	dude.x = 200
	dude.y = 200
	dude.vx = 0
	dude.vy = 0
	dude.friction = 0.001
	dude.speed = 2
	dude.direction = 0

	command.x = 200
	command.y = 200

	hover.x = 1
	hover.y = 1
	current.x = 15
	current.y = 15


	-- map = {}
	-- for x = 1, 30 do
	-- 	map[x] = {}
	-- 	for y = 1, 30 do
	-- 		map[x][y] = 1
	-- 	end
	-- end

	map = {
	{2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,2,2,2,1,1,1,1,1,2,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,1,1,1},
	{1,1,1,1,1,1,1,2,2,2,2,2,2,2,2,2,2,2,2,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1},
	{1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2}}

	nodesize = 16

	path = {}
	pathfinder = Pathfinder(map)


end

function love.update(dt)
	dude.vx = command.x - dude.x
	dude.vy = command.y - dude.y

	dude.x = dude.x + dude.vx * dude.speed * dt
	dude.y = dude.y + dude.vy * dude.speed * dt
end

function love.mousepressed(mx,my,bt)
	command.x = hover.x
	command.y = hover.y

	pathfinder:find(current.x, current.y, command.x, command.y)
	path = pathfinder.path

end

function love.draw()
	if love.keyboard.isDown("escape") then
		width, height, fullscreen, vsync, fsaa = love.graphics.getMode()
		if not fullscreen then
			success = love.graphics.setMode(1600, 900, true, true, 0)
		else
			success = love.graphics.setMode(800, 600, false, true, 0)
		end
	end

   	for x = 1, #map do
		for y = 1, #map do
			local cx = y*nodesize
			local cy = x*nodesize
			local mx = love.mouse.getX()
			local my = love.mouse.getY()
			if mx < cx+nodesize and mx > cx and my < cy+nodesize and my > cy then
   				love.graphics.setColor( 255, 0, 0, 255 )
		   		love.graphics.rectangle("fill", cx, cy, nodesize, nodesize)
		   		hover.x = x
		   		hover.y = y
		   	else
		   		if current.x == x and current.y == y then
   					love.graphics.setColor( 60, 255, 60, 255 )
   				elseif _.detect(path, function (i) return i.x == x and i.y == y end) ~= nil then
   					love.graphics.setColor( 40, 0, 255, 255 )
				elseif map[x][y].tile == 2 then
					love.graphics.setColor( 255, 255, 255, 255 )
   				else
   					love.graphics.setColor( 60, 0, 0, 255 )
   				end
		   		love.graphics.rectangle("fill", cx, cy, nodesize, nodesize)
		   	end
		end
	end
   	love.graphics.setColor( 255, 255, 255, 255 )
   	love.graphics.print("Current FPS: "..tostring(love.timer.getFPS( )), 10, 10)
   	-- love.graphics.print("Hover: "..tostring(hover.x).." "..tostring(hover.y), 10, 25)
end