-- WORLD Class --

local world = {}
world.__index = world

setmetatable(world, {
	__call = function (cls, ...)
		return cls.new(...)
		end,
	})

function world.new()
	local self = setmetatable({}, world)
		self.entities = {}
	return self
end


function world:render()
	for x = 1,#grid do
		for y = 1, #grid do
			-- switch tile graphics based on world
			if 	   grid[x][y].tile == 1 then current = grass 
			elseif grid[x][y].tile == 2 then current = mage 
			elseif grid[x][y].tile == 3 then current = rocks 
			elseif grid[x][y].tile == 4 then current = bush 
			elseif grid[x][y].tile == 5 then current = tree 
			else current = grass
			end

			-- calculate block location
			pixelx, pixely = isotoscreen(x, y)

			-- draw world
			love.graphics.draw(current, pixelx, pixely)

			--calculations
			tilex, tiley = screentoiso(love.mouse.getX()/scale, love.mouse.getY()/scale)

			hover.x = tilex
			hover.y = tiley
		end
	end
end


function loadworld(file)
	-- possible tile designations
	local possible = "12345"

	local world = {}
	local lines = {}
  for line in io.lines(file) do 
    lines[#lines + 1] = line
  end

    for i=1, #lines do
    	local line = {}
    	for u=1, string.len(lines[i]) do
    		nextchar = string.sub(lines[i], u, u)
    		if possible:find(nextchar) then
    			line[u] = nextchar
			end
		end
		world[#world + 1] = line
 	end
 	return world
end
